#ifndef IR_H_INCLUDED
#define IR_H_INCLUDED

typedef enum {
    IR_UNKNOWN,
    IR_RC5,
    IR_NEC,
    IR_KAS
} IR_PROTOCOL;

typedef struct {
    IR_PROTOCOL protocol;
    uint8_t address;
    uint8_t command;
} IR_PACKET;

void IR_Init(void);
void IR_Activate(void);
void (*IR_SignalAppear)(void);
void (*IR_SignalDisappear)(void);
void (*IR_PacketReceived)(IR_PACKET);

#endif // IR_H_INCLUDED
