#include <avr/io.h>
#include <avr/interrupt.h>
#include "ATmega88PA.h"
#include "stub.h"
#include "usart.h"

void USART_Setup_8N1(void) {
    USART_8BIT_DATA_FRAME;
    USART_NO_PARITY;
    USART_ONE_STOP_BIT;
}

void USART_SendData(uint8_t data) {
    // Wait until last byte has been transmitted
    while((UCSR0A &(1<<UDRE0)) == 0);
    USART_SEND_BYTE(data);
}

void USART_Init(void) {
    USART_DataReceived = STUB_uint8;
    USART_DataRegisterEmpty = STUB_void;
    USART_RECEIVE_COMPLETE_INTERRUPT_ENABLE;
    USART_RECEIVER_DISABLE;
    USART_TRAMSMITTER_DISABLE;
}

void USART_Activate(void) {
    USART_RECEIVER_ENABLE;
    USART_TRAMSMITTER_ENABLE;
}

ISR(USART_RX_vect) {
    USART_DataReceived(UDR0);
}

ISR(USART_UDRE_vect) {
    USART_DataRegisterEmpty();
}
